> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.vellum.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.vellum.ai/_mcp/server.

# Bulk Update Test Cases

POST https://api.vellum.ai/v1/test-suites/{id}/test-cases-bulk
Content-Type: application/x-ndjson

Created, replace, and delete Test Cases within the specified Test Suite in bulk

Reference: https://docs.vellum.ai/developers/client-sdk/test-suites/test-cases/bulk-update

## Authentication

- `X-API-KEY` header (required) — API Key authentication via header

## Request

### Path parameters

- `id` (string, required) — Either the Test Suites' ID or its unique name

### Body (application/x-ndjson)

This endpoint expects a list of TestSuiteTestCaseBulkOperationRequest.

- `list of TestSuiteTestCaseBulkOperationRequest`

## Response

### 200

- Streaming response of `list of TestSuiteTestCaseBulkResult`.

## Types

### TestSuiteTestCaseBulkOperationRequest

### TestSuiteTestCaseBulkResult

### TestSuiteTestCaseCreateBulkOperationRequest

A bulk operation that represents the creation of a Test Case.

- `id` (string, required) — An ID representing this specific operation. Can later be used to look up information about the operation's success in the response.
- `type` (enum, required)
  - Allowed values: `CREATE`
- `data` (CreateTestSuiteTestCaseRequest, required) — Information about the Test Case to create

### TestSuiteTestCaseReplaceBulkOperationRequest

A bulk operation that represents the replacing of a Test Case.

- `id` (string, required) — An ID representing this specific operation. Can later be used to look up information about the operation's success in the response.
- `type` (enum, required)
  - Allowed values: `REPLACE`
- `data` (ReplaceTestSuiteTestCaseRequest, required) — Information about the Test Case to replace

### TestSuiteTestCaseUpsertBulkOperationRequest

A bulk operation that represents the upserting of a Test Case.

- `id` (string, required) — An ID representing this specific operation. Can later be used to look up information about the operation's success in the response.
- `type` (enum, required)
  - Allowed values: `UPSERT`
- `data` (UpsertTestSuiteTestCaseRequest, required)

### TestSuiteTestCaseDeleteBulkOperationRequest

A bulk operation that represents the deletion of a Test Case.

- `id` (string, required) — An ID representing this specific operation. Can later be used to look up information about the operation's success in the response.
- `type` (enum, required)
  - Allowed values: `DELETE`
- `data` (TestSuiteTestCaseDeleteBulkOperationDataRequest, required) — Information about the Test Case to delete

### TestSuiteTestCaseCreatedBulkResult

The result of a bulk operation that created a Test Case.

- `id` (string, required)
- `type` (enum, required)
  - Allowed values: `CREATED`
- `data` (TestSuiteTestCaseCreatedBulkResultData, required) — Information about the Test Case that was created.

### TestSuiteTestCaseReplacedBulkResult

The result of a bulk operation that replaced a Test Case.

- `id` (string, required) — An ID that maps back to one of the initially supplied operations. Can be used to determine the result of a given operation.
- `type` (enum, required)
  - Allowed values: `REPLACED`
- `data` (TestSuiteTestCaseReplacedBulkResultData, required) — Information about the Test Case that was replaced

### TestSuiteTestCaseDeletedBulkResult

The result of a bulk operation that deleted a Test Case.

- `id` (string, required) — An ID that maps back to one of the initially supplied operations. Can be used to determine the result of a given operation.
- `type` (enum, required)
  - Allowed values: `DELETED`
- `data` (TestSuiteTestCaseDeletedBulkResultData, required) — Information about the Test Case that was deleted

### TestSuiteTestCaseRejectedBulkResult

The result of a bulk operation that failed to operate on a Test Case.

- `type` (enum, required)
  - Allowed values: `REJECTED`
- `data` (map from string to any, required) — Details about the error that occurred
- `id` (string, optional, nullable) — An ID that maps back to one of the initially supplied operations. Can be used to determine the result of a given operation.

### CreateTestSuiteTestCaseRequest

Information about the Test Case to create

- `input_values` (list of NamedTestCaseVariableValueRequest, required) — Values for each of the Test Case's input variables
- `evaluation_values` (list of NamedTestCaseVariableValueRequest, required) — Values for each of the Test Case's evaluation variables
- `label` (string, optional, nullable) — A human-readable label used to convey the intention of this Test Case
- `external_id` (string, optional, nullable) — Optionally provide an ID that uniquely identifies this Test Case in your system. Useful for updating this Test Cases data after initial creation. Cannot be changed later.

### ReplaceTestSuiteTestCaseRequest

Information about the Test Case to replace

- `input_values` (list of NamedTestCaseVariableValueRequest, required) — Values for each of the Test Case's input variables
- `evaluation_values` (list of NamedTestCaseVariableValueRequest, required) — Values for each of the Test Case's evaluation variables
- `id` (string, optional, nullable) — The Vellum-generated ID of the Test Case whose data you'd like to replace. Must specify either this or external_id.
- `external_id` (string, optional, nullable) — The ID that was originally provided upon Test Case creation that uniquely identifies the Test Case whose data you'd like to replace. Must specify either this of id.
- `label` (string, optional, nullable) — A human-readable label used to convey the intention of this Test Case

### UpsertTestSuiteTestCaseRequest

- `input_values` (list of NamedTestCaseVariableValueRequest, required) — Values for each of the Test Case's input variables
- `evaluation_values` (list of NamedTestCaseVariableValueRequest, required) — Values for each of the Test Case's evaluation variables
- `id` (string, optional) — The Vellum-generated ID of an existing Test Case whose data you'd like to replace. If specified and no Test Case exists with this ID, a 404 will be returned.
- `external_id` (string, optional) — An ID external to Vellum that uniquely identifies the Test Case that you'd like to create/update. If there's a match on a Test Case that was previously created with the same external_id, it will be updated. Otherwise, a new Test Case will be created with this value as its external_id. If no external_id is specified, then a new Test Case will always be created.
- `label` (string, optional, nullable) — A human-readable label used to convey the intention of this Test Case

### TestSuiteTestCaseDeleteBulkOperationDataRequest

- `id` (string, required)

### TestSuiteTestCaseCreatedBulkResultData

Information about the Test Case that was created.

- `id` (string, required)

### TestSuiteTestCaseReplacedBulkResultData

Information about the Test Case that was replaced

- `id` (string, required)

### TestSuiteTestCaseDeletedBulkResultData

Information about the Test Case that was deleted

- `id` (string, required)

### NamedTestCaseVariableValueRequest

### NamedTestCaseStringVariableValueRequest

Named Test Case value that is of type STRING

- `type` (enum, required)
  - Allowed values: `STRING`
- `value` (string, required, nullable)
- `name` (string, required)

### NamedTestCaseNumberVariableValueRequest

Named Test Case value that is of type NUMBER

- `type` (enum, required)
  - Allowed values: `NUMBER`
- `value` (double, required, nullable)
- `name` (string, required)

### NamedTestCaseJsonVariableValueRequest

Named Test Case value that is of type JSON

- `type` (enum, required)
  - Allowed values: `JSON`
- `value` (any, required, nullable)
- `name` (string, required)

### NamedTestCaseChatHistoryVariableValueRequest

Named Test Case value that is of type CHAT_HISTORY

- `type` (enum, required)
  - Allowed values: `CHAT_HISTORY`
- `value` (list of ChatMessageRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseSearchResultsVariableValueRequest

Named Test Case value that is of type SEARCH_RESULTS

- `type` (enum, required)
  - Allowed values: `SEARCH_RESULTS`
- `value` (list of SearchResultRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseErrorVariableValueRequest

Named Test Case value that is of type ERROR

- `type` (enum, required)
  - Allowed values: `ERROR`
- `value` (VellumErrorRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseFunctionCallVariableValueRequest

Named Test Case value that is of type FUNCTION_CALL

- `type` (enum, required)
  - Allowed values: `FUNCTION_CALL`
- `value` (FunctionCallRequest, required, nullable) — The final resolved function call value.
- `name` (string, required)

### NamedTestCaseArrayVariableValueRequest

Named Test Case value that is of type ARRAY

- `type` (enum, required)
  - Allowed values: `ARRAY`
- `value` (list of VellumValueRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseAudioVariableValueRequest

Named Test Case value that is of type AUDIO

- `type` (enum, required)
  - Allowed values: `AUDIO`
- `value` (VellumAudioRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseVideoVariableValueRequest

- `type` (enum, required)
  - Allowed values: `VIDEO`
- `value` (VellumVideoRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseImageVariableValueRequest

- `type` (enum, required)
  - Allowed values: `IMAGE`
- `value` (VellumImageRequest, required, nullable)
- `name` (string, required)

### NamedTestCaseDocumentVariableValueRequest

- `type` (enum, required)
  - Allowed values: `DOCUMENT`
- `value` (VellumDocumentRequest, required, nullable)
- `name` (string, required)

### ChatMessageRequest

- `role` (enum, required) — * `SYSTEM` - System * `ASSISTANT` - Assistant * `USER` - User * `FUNCTION` - Function
  - Allowed values: `SYSTEM`, `ASSISTANT`, `USER`, `FUNCTION`
- `text` (string, optional, nullable)
- `content` (ChatMessageContentRequest, optional, nullable)
- `source` (string, optional, nullable) — An optional identifier representing who or what generated this message.
- `metadata` (map from string to any, optional, nullable)

### SearchResultRequest

- `text` (string, required) — The text of the chunk that matched the search query.
- `score` (double, required) — A score representing how well the chunk matches the search query.
- `keywords` (list of string, required)
- `document` (SearchResultDocumentRequest, required) — The document that contains the chunk that matched the search query.
- `meta` (SearchResultMetaRequest, optional, nullable) — Additional information about the search result.

### VellumErrorRequest

- `code` (enum, required) — * `INVALID_REQUEST` - INVALID_REQUEST * `INVALID_INPUTS` - INVALID_INPUTS * `PROVIDER_ERROR` - PROVIDER_ERROR * `PROVIDER_CREDENTIALS_UNAVAILABLE` - PROVIDER_CREDENTIALS_UNAVAILABLE * `INTEGRATION_CREDENTIALS_UNAVAILABLE` - INTEGRATION_CREDENTIALS_UNAVAILABLE * `REQUEST_TIMEOUT` - REQUEST_TIMEOUT * `INTERNAL_SERVER_ERROR` - INTERNAL_SERVER_ERROR * `USER_DEFINED_ERROR` - USER_DEFINED_ERROR * `WORKFLOW_CANCELLED` - WORKFLOW_CANCELLED * `NODE_CANCELLED` - NODE_CANCELLED * `PROVIDER_QUOTA_EXCEEDED` - PROVIDER_QUOTA_EXCEEDED * `CHAT_QUOTA_EXCEEDED` - CHAT_QUOTA_EXCEEDED
  - Allowed values: `INVALID_REQUEST`, `INVALID_INPUTS`, `PROVIDER_ERROR`, `PROVIDER_CREDENTIALS_UNAVAILABLE`, `INTEGRATION_CREDENTIALS_UNAVAILABLE`, `REQUEST_TIMEOUT`, `INTERNAL_SERVER_ERROR`, `USER_DEFINED_ERROR`, `WORKFLOW_CANCELLED`, `NODE_CANCELLED`, `PROVIDER_QUOTA_EXCEEDED`, `CHAT_QUOTA_EXCEEDED`
- `message` (string, required)
- `raw_data` (map from string to any, optional, nullable)

### FunctionCallRequest

The final resolved function call value.

- `arguments` (map from string to any, required)
- `name` (string, required)
- `id` (string, optional, nullable)

### VellumValueRequest

### VellumAudioRequest

- `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details.
- `metadata` (map from string to any, optional, nullable)

### VellumVideoRequest

- `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details.
- `metadata` (map from string to any, optional, nullable)

### VellumImageRequest

- `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details.
- `metadata` (map from string to any, optional, nullable)

### VellumDocumentRequest

- `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details.
- `metadata` (map from string to any, optional, nullable)

### ChatMessageContentRequest

### SearchResultDocumentRequest

- `label` (string, required) — The human-readable name for the document.
- `id` (string, optional, nullable) — The ID of the document.
- `external_id` (string, optional, nullable) — The unique ID of the document as represented in an external system and specified when it was originally uploaded.
- `metadata` (map from string to any, optional, nullable) — A previously supplied JSON object containing metadata that can be filtered on when searching.

### SearchResultMetaRequest

- `source` (SearchResultMetaSourceRequest, optional, nullable)

### StringVellumValueRequest

A value representing a string.

- `type` (enum, required)
  - Allowed values: `STRING`
- `value` (string, required, nullable)

### NumberVellumValueRequest

A value representing a number.

- `type` (enum, required)
  - Allowed values: `NUMBER`
- `value` (double, required, nullable)

### JsonVellumValueRequest

A value representing a JSON object.

- `type` (enum, required)
  - Allowed values: `JSON`
- `value` (any, required, nullable)

### AudioVellumValueRequest

A base Vellum primitive value representing audio.

- `type` (enum, required)
  - Allowed values: `AUDIO`
- `value` (VellumAudioRequest, required, nullable)

### VideoVellumValueRequest

A base Vellum primitive value representing a video.

- `type` (enum, required)
  - Allowed values: `VIDEO`
- `value` (VellumVideoRequest, required, nullable)

### ImageVellumValueRequest

A base Vellum primitive value representing an image.

- `type` (enum, required)
  - Allowed values: `IMAGE`
- `value` (VellumImageRequest, required, nullable)

### DocumentVellumValueRequest

A base Vellum primitive value representing a document.

- `type` (enum, required)
  - Allowed values: `DOCUMENT`
- `value` (VellumDocumentRequest, required, nullable)

### FunctionCallVellumValueRequest

A value representing a Function Call.

- `type` (enum, required)
  - Allowed values: `FUNCTION_CALL`
- `value` (FunctionCallRequest, required, nullable) — The final resolved function call value.

### ErrorVellumValueRequest

A value representing an Error.

- `type` (enum, required)
  - Allowed values: `ERROR`
- `value` (VellumErrorRequest, required, nullable)

### ArrayVellumValueRequest

A value representing an array of Vellum variable values.

- `type` (enum, required)
  - Allowed values: `ARRAY`
- `value` (list of VellumValueRequest, required, nullable)

### ChatHistoryVellumValueRequest

A value representing Chat History.

- `type` (enum, required)
  - Allowed values: `CHAT_HISTORY`
- `value` (list of ChatMessageRequest, required, nullable)

### SearchResultsVellumValueRequest

A value representing Search Results.

- `type` (enum, required)
  - Allowed values: `SEARCH_RESULTS`
- `value` (list of SearchResultRequest, required, nullable)

### ThinkingVellumValueRequest

A value representing Thinking mode output.

- `type` (enum, required)
  - Allowed values: `THINKING`
- `value` (StringVellumValueRequest, required, nullable) — A value representing a string.

### StringChatMessageContentRequest

A string value that is used in a chat message.

- `type` (enum, required)
  - Allowed values: `STRING`
- `value` (string, required)

### FunctionCallChatMessageContentRequest

A function call value that is used in a chat message.

- `type` (enum, required)
  - Allowed values: `FUNCTION_CALL`
- `value` (FunctionCallChatMessageContentValueRequest, required) — The final resolved function call value.

### ArrayChatMessageContentRequest

A list of chat message content items.

- `type` (enum, required)
  - Allowed values: `ARRAY`
- `value` (list of ArrayChatMessageContentItemRequest, required)

### AudioChatMessageContentRequest

An audio value that is used in a chat message.

- `type` (enum, required)
  - Allowed values: `AUDIO`
- `value` (VellumAudioRequest, required)

### VideoChatMessageContentRequest

A video value that is used in a chat message.

- `type` (enum, required)
  - Allowed values: `VIDEO`
- `value` (VellumVideoRequest, required)

### ImageChatMessageContentRequest

An image value that is used in a chat message.

- `type` (enum, required)
  - Allowed values: `IMAGE`
- `value` (VellumImageRequest, required)

### DocumentChatMessageContentRequest

A document value that is used in a chat message.

- `type` (enum, required)
  - Allowed values: `DOCUMENT`
- `value` (VellumDocumentRequest, required)

### SearchResultMetaSourceRequest

### FunctionCallChatMessageContentValueRequest

The final resolved function call value.

- `name` (string, required)
- `arguments` (map from string to any, required)
- `id` (string, optional, nullable)

### ArrayChatMessageContentItemRequest

### PdfSearchResultMetaSourceRequest

The source of a search result from a PDF document.

- `document_type` (enum, required)
  - Allowed values: `PDF`
- `start_page_num` (integer, required, nullable) — The 1-indexed page number where the chunk starts in the document. Only available for supported chunking strategies and document types.
- `end_page_num` (integer, required, nullable) — The 1-indexed page number where the chunk ends in the document. Only available for supported chunking strategies and document types.

## Examples

**Request**

```json
[
  {
    "id": "string",
    "type": "CREATE",
    "data": {
      "input_values": [
        {
          "type": "STRING",
          "value": "string",
          "name": "string"
        }
      ],
      "evaluation_values": [
        {
          "type": "STRING",
          "value": "string",
          "name": "string"
        }
      ]
    }
  }
]
```

**Response**

```json
[
  {
    "type": "json",
    "value": [
      {
        "id": "string",
        "type": "CREATED",
        "data": {
          "id": "string"
        }
      }
    ]
  }
]
```

**SDK Code**

```python
import requests

url = "https://api.vellum.ai/v1/test-suites/id/test-cases-bulk"

payload = "[\n  {\n    \"id\": \"string\",\n    \"type\": \"CREATE\",\n    \"data\": {\n      \"input_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"evaluation_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ]\n    }\n  }\n]"
headers = {
    "X-API-KEY": "<apiKey>",
    "Content-Type": "application/x-ndjson"
}

response = requests.post(url, data=payload, headers=headers)

print(response.json())
```

```typescript
import { VellumClient } from "vellum-ai";

const client = new VellumClient({ apiKey: "YOUR_API_KEY", apiVersion: "YOUR_API_VERSION" });
const response = await client.testSuites.testSuiteTestCasesBulk("id", [{
        id: "id",
        type: "CREATE",
        data: {
            inputValues: [{
                    type: "STRING",
                    name: "x"
                }, {
                    type: "STRING",
                    name: "x"
                }],
            evaluationValues: [{
                    type: "STRING",
                    name: "x"
                }, {
                    type: "STRING",
                    name: "x"
                }]
        }
    }, {
        id: "id",
        type: "CREATE",
        data: {
            inputValues: [{
                    type: "STRING",
                    name: "x"
                }, {
                    type: "STRING",
                    name: "x"
                }],
            evaluationValues: [{
                    type: "STRING",
                    name: "x"
                }, {
                    type: "STRING",
                    name: "x"
                }]
        }
    }]);
for await (const item of response) {
    console.log(item);
}

```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.vellum.ai/v1/test-suites/id/test-cases-bulk"

	payload := strings.NewReader("[\n  {\n    \"id\": \"string\",\n    \"type\": \"CREATE\",\n    \"data\": {\n      \"input_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"evaluation_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ]\n    }\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-API-KEY", "<apiKey>")
	req.Header.Add("Content-Type", "application/x-ndjson")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.vellum.ai/v1/test-suites/id/test-cases-bulk")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-API-KEY"] = '<apiKey>'
request["Content-Type"] = 'application/x-ndjson'
request.body = "[\n  {\n    \"id\": \"string\",\n    \"type\": \"CREATE\",\n    \"data\": {\n      \"input_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"evaluation_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ]\n    }\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.vellum.ai/v1/test-suites/id/test-cases-bulk")
  .header("X-API-KEY", "<apiKey>")
  .header("Content-Type", "application/x-ndjson")
  .body("[\n  {\n    \"id\": \"string\",\n    \"type\": \"CREATE\",\n    \"data\": {\n      \"input_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"evaluation_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ]\n    }\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.vellum.ai/v1/test-suites/id/test-cases-bulk', [
  'body' => '[
  {
    "id": "string",
    "type": "CREATE",
    "data": {
      "input_values": [
        {
          "type": "STRING",
          "value": "string",
          "name": "string"
        }
      ],
      "evaluation_values": [
        {
          "type": "STRING",
          "value": "string",
          "name": "string"
        }
      ]
    }
  }
]',
  'headers' => [
    'Content-Type' => 'application/x-ndjson',
    'X-API-KEY' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.vellum.ai/v1/test-suites/id/test-cases-bulk");
var request = new RestRequest(Method.POST);
request.AddHeader("X-API-KEY", "<apiKey>");
request.AddHeader("Content-Type", "application/x-ndjson");
request.AddParameter("application/x-ndjson", "[\n  {\n    \"id\": \"string\",\n    \"type\": \"CREATE\",\n    \"data\": {\n      \"input_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"evaluation_values\": [\n        {\n          \"type\": \"STRING\",\n          \"value\": \"string\",\n          \"name\": \"string\"\n        }\n      ]\n    }\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-API-KEY": "<apiKey>",
  "Content-Type": "application/x-ndjson"
]

let postData = NSData(data: "[
  {
    "id": "string",
    "type": "CREATE",
    "data": {
      "input_values": [
        {
          "type": "STRING",
          "value": "string",
          "name": "string"
        }
      ],
      "evaluation_values": [
        {
          "type": "STRING",
          "value": "string",
          "name": "string"
        }
      ]
    }
  }
]".data(using: String.Encoding.utf8)!)

let request = NSMutableURLRequest(url: NSURL(string: "https://api.vellum.ai/v1/test-suites/id/test-cases-bulk")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```